From 9986e8f9b1fbe22fd98b742d5f934229e2aa3483 Mon Sep 17 00:00:00 2001
In-Reply-To: <20160514043456.GA17412@benfinney.id.au>
References: <20160514043456.GA17412@benfinney.id.au>
From: Ben Finney <bignose@debian.org>
Date: Fri, 7 Jul 2017 11:42:47 +1000
Subject: [PATCH 4/4] Correctly match filesystem entries for different options.

---
 scripts/debdiff.bash_completion | 23 ++++++++++++++---------
 1 file changed, 14 insertions(+), 9 deletions(-)

diff --git a/scripts/debdiff.bash_completion b/scripts/debdiff.bash_completion
index 381d8fd7..12405684 100644
--- a/scripts/debdiff.bash_completion
+++ b/scripts/debdiff.bash_completion
@@ -92,28 +92,33 @@ _debdiff () {
     case $file_list_mode in
         normal)
             if [[ $prev == --debs-dir ]]; then
-                COMPREPLY=$( ( compgen -d -- "$cur" ) )
+                COMPREPLY=( $( compgen -G "${cur}*" ) )
+                compopt -o dirnames
             elif [[ $cur == -* ]]; then
                 COMPREPLY=( $( compgen -W "${options[*]}" -- "$cur" ) )
             else
-                declare -a _compreply=( $( compgen -o filenames -G '*.@(deb|dsc|changes)' ) )
-                COMPREPLY=( $( compgen -W "${_compreply[*]}" -- "$cur" ) )
+                COMPREPLY=( $( compgen -G "${cur}*.@(deb|dsc|changes)" ) )
+                compopt -o filenames
+                compopt -o plusdirs
             fi
             ;;
         deb|from|to)
-            declare -a _compreply=( $( compgen -o filenames -G '*.deb' ) )
-            COMPREPLY=( $( compgen -W "${_compreply[*]}" -- "$cur" ) )
+            COMPREPLY=( $( compgen -G "${cur}*.deb" ) )
             if (( $move_from > 0 && $move_to < 0 )) ; then
                 COMPREPLY+=( $( compgen -W "--to" -- "$cur" ) )
             fi
+            compopt -o filenames
+            compopt -o plusdirs
             ;;
         dsc)
-            declare -a _compreply=( $( compgen -o filenames -G '*.dsc' ) )
-            COMPREPLY=( $( compgen -W "${_compreply[*]}" -- "$cur" ) )
+            COMPREPLY=( $( compgen -G "${cur}*.dsc" ) )
+            compopt -o filenames
+            compopt -o plusdirs
             ;;
         changes)
-            declare -a _compreply=( $( compgen -o filenames -G '*.changes' ) )
-            COMPREPLY=( $( compgen -W "${_compreply[*]}" -- "$cur" ) )
+            COMPREPLY=( $( compgen -G "${cur}*.changes" ) )
+            compopt -o filenames
+            compopt -o plusdirs
             ;;
         *)
             COMPREPLY=( $( compgen -W "${options[*]}" -- "$cur" ) )
-- 
2.11.0

